package beilv.web.controller.carinformation;

import beilv.cardpurchaserecord.domain.CardPurchaseRecord;
import beilv.cardpurchaserecord.service.ICardPurchaseRecordService;
import beilv.carinformation.domain.CarInformation;
import beilv.carinformation.service.ICarInformationService;
import beilv.common.core.controller.BaseController;
import beilv.common.core.domain.AjaxResult;
import beilv.system.service.ISysMemberService;
import beilv.usermembershipcard.domain.UserMembershipCard;
import beilv.usermembershipcard.service.IUserMembershipCardService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * 会员卡AppController
 *
 * @author ruoyi
 * @date 2025-01-02
 */
@Controller
@RequestMapping("/app-api/cardApp")
public class cardAppController extends BaseController {

    @Autowired
    private ICarInformationService carInformationService;

    @Autowired
    private ICardPurchaseRecordService cardPurchaseRecordService;

    @Autowired
    private IUserMembershipCardService userMembershipCardService;

    @Autowired
    private ISysMemberService iSysMemberService;
    /**
     * 查询卡种信息列表
     */
    @PostMapping("/cardInformationlist")
    @ResponseBody
    public AjaxResult cardInformationlist(@RequestBody CarInformation carInformation) {
        return AjaxResult.success(carInformationService.selectCarInformationList(carInformation));
    }

    /**
     * 新增保存购卡记录
     */
    @PostMapping("/addCard")
    @ResponseBody
    public AjaxResult addCard(@RequestBody CardPurchaseRecord cardPurchaseRecord) {
        return toAjax(cardPurchaseRecordService.insertCardPurchaseRecord(cardPurchaseRecord));
    }

    /**
     * 查询用户会员卡列表
     */
    @PostMapping("/getUserCardList")
    @ResponseBody
    public AjaxResult getUserCardList(@RequestBody UserMembershipCard userMembershipCard) {
        return AjaxResult.success(userMembershipCardService.selectUserMembershipCardList(userMembershipCard));
    }
}
