package beilv.admissionticket.domain;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.math.BigDecimal;
import java.util.Date;

@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
public class AdmissionTicket {
    /**
     * 门票id
     */
    private String id;
    /**
     * 场馆id
     */
    private String venueId;
    /**
     * 场地名称
     */
    private String siteId;
    /**
     * 场地类型
     */
    private String siteType;
    /**
     * 场地时段
     */
    private String session;
    /**
     * 时段价格
     */
    private BigDecimal price;
    /**
     * 日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    private Date ticketDate;
    /**
     * 门票状态
     */
    private String admissionTicketStatus;

    /**
     * 场地名称
     */
    private String venueName;

    /**
     * 排序
     */
    private int sort;

    private String siteName;

    public AdmissionTicket(String id, String venueId, String siteId, String siteType, String session, BigDecimal price, Date ticketDate, String admissionTicketStatus, String venueName, int sort) {
        this.id = id;
        this.venueId = venueId;
        this.siteId = siteId;
        this.siteType = siteType;
        this.session = session;
        this.price = price;
        this.ticketDate = ticketDate;
        this.admissionTicketStatus = admissionTicketStatus;
        this.venueName = venueName;
        this.sort = sort;
    }
}
