package beilv.shopping.domain;

import java.math.BigDecimal;
import java.util.List;

import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import beilv.common.annotation.Excel;
import beilv.common.core.domain.BaseEntity;

/**
 * 商城对象 qmjs_shopping_mall
 * 
 * @author lc
 * @date 2025-01-02
 */
@Data
public class QmjsShoppingMall extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键id */
    private Long id;

    /** 商品名称 */
    @Excel(name = "商品名称")
    private String goodsName;

    /** 商品条码 */
    @Excel(name = "商品条码")
    private String goodsCode;

    /** 商品种类 */
    @Excel(name = "商品种类")
    private String goodsType;

    /** 商品图片 */
    @Excel(name = "商品图片")
    private String goodsImg;

//    private String[] imageUrlsArray;

    /** 商品说明 */
    @Excel(name = "商品说明")
    private String goodsDescribe;

    /** 计量单位 */
    @Excel(name = "计量单位")
    private String goodsUnit;

    /** 时价商品（是/否） */
    @Excel(name = "时价商品", readConverterExp = "是=/否")
    private String goodsCurrentPrice;

    /** 销售单价 */
    @Excel(name = "销售单价")
    private BigDecimal salePrice;

    /** 建议售价 */
    @Excel(name = "建议售价")
    private BigDecimal suggestionPrice;

    /** 商品库存 */
    @Excel(name = "商品库存")
    private String goodsInventory;

    /** 库存成本 */
    @Excel(name = "库存成本")
    private BigDecimal inventoryCost;

    /** 商品状态(正常/禁用) */
    @Excel(name = "商品状态(正常/禁用)")
    private String goodsState;

}
